#pragma once

#include <string>

class ClapTrap
{
	protected:
		std::string _name;
		int			_life;
		int			_energy;
		int			_damage;

	public:
		ClapTrap();
		ClapTrap(const ClapTrap& src);
		ClapTrap(const std::string& name);
		virtual ~ClapTrap();

		ClapTrap &operator=(const ClapTrap& src);

		virtual void attack(const std::string& target);
		void takeDamage(unsigned int amount);
		void beRepaired(unsigned int amount);

		const std::string& getName() const;
		int getLife() const;
		int getEnergy() const;
		int getDamage() const;
};
